/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CATEGORY_H
#define CATEGORY_H

#include <string>
#include <QColor>

#include <QApplication>

struct Category
{
    int id;
    int parent;
    QString name;
    QColor backcolor; 
    QColor forecolor; 
    QString font;
    bool fix_cost;

    bool operator() (const Category& cat1, const Category& cat2) const
    {
        if (cat1.fix_cost) return true;
        if (cat2.fix_cost) return false;

	return QApplication::translate("", cat1.name.toStdString().c_str()) < QApplication::translate("", cat2.name.toStdString().c_str());
    }

    bool operator == (int catId)
    {
        return id == catId;
    }
};

#endif
