/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Operation.hpp"

bool sortOperations(const Operation& op1, const Operation& op2)
{
    if (!op1.fix_cost && op2.fix_cost) return false;
    if (op1.fix_cost && !op2.fix_cost) return true;

    if (op1.year < op2.year)
	return true;
    else if (op1.year == op2.year)
    {
	if (op1.month < op2.month)
	    return true;
	else if (op1.month == op2.month)
	{
	    if (op1.day < op2.day)
		return true;
	    else if (op1.day == op2.day)
		return (op1.description < op2.description);
	}
    }

    return false;
}

bool reverseSortOperations(const Operation& op1, const Operation& op2)
{
    return !sortOperations(op1, op2);
}
