/*
  Copyright 2010-2013 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CSVEXPORTENGINE_H
#define CSVEXPORTENGINE_H

#include <model/model.hpp>
#include <controller/KissCount.hpp>
#include "ExportEngine.hpp"

class CSVExportEngine : public ExportEngine {
public:
    CSVExportEngine();
    ~CSVExportEngine();

    bool HandleFile(const QString& path, User* user, Database* db, KissCount* kiss);
    bool SaveFile(std::vector<Operation>* operations);

private:
    QTextStream* _writer;

    bool SaveAccounts();
    bool SaveAccountAmounts();
    bool SaveCategories();
    bool SaveTags();
    bool SaveOperations(std::vector<Operation>* operations);
};

#endif
