/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef OFXIMPORTENGINE_H
#define OFXIMPORTENGINE_H

#ifndef WIN32

#include "ImportEngine.hpp"
#include <libofx/libofx.h>

class OFXImportEngine : public ImportEngine {
public:
    OFXImportEngine();
    ~OFXImportEngine();

    virtual bool HandleFile(const QString& path, User* user, Database* db, KissCount* kiss);
    /* virtual std::vector<wxString> ParseFile(); */
    /* virtual std::vector<Operation>* GetOperations(std::map<wxString, wxString>& accounts); */

private:
    LibofxContextPtr _ctx;
    int _curAccount;

    static int account_cb(const struct OfxAccountData data, void * account_data);
    static int transaction_cb(const struct OfxTransactionData data, void * transaction_data);
    static int account_balance_cb(const struct OfxStatementData data, void * statement_data);
};

#endif

#endif
