/*
  Copyright 2010-2013 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COSTREPARTITIONBANNER_H
#define COSTREPARTITIONBANNER_H

#include <QtGui>
#include <QTableWidget>
#include <QtCharts/QChart>

#include "view.hpp"
#include <model/model.hpp>

class CostRepartitionBanner: public QFrame
{
    Q_OBJECT;

public:
    CostRepartitionBanner(KissCount* kiss, QFrame* parent, QString* categories);

    void Reset();
    void UpdateCosts(int *categoriesValues, int totalDebit);

private:
    KissCount* _kiss;
    QString* _categories;
    QTableWidget* _statsGrid;
    QtCharts::QChart* _pie;
    QStandardItemModel* _dataset;
};

#endif
