/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef EXPORTPANEL_H
#define EXPORTPANEL_H

#include <QtGui>

#include "view.hpp"
#include "grid/GridAccount.hpp"
#include "AccountPanel.hpp"
#include "SearchBanner.hpp"
#include <model/model.hpp>
#include <model/export/ExportEngine.hpp>

class GridAccount;
class SearchBanner;
class ExportEngine;

class ExportPanel: public KissPanel
{
    Q_OBJECT;

public:
    ExportPanel(KissCount* kiss, wxUI *parent, bool lowResolution);
    ~ExportPanel();

    KissPanel* CreatePanel();
    QString GetToolTip();
    void OnShow();

private slots:
    void OnButtonSearch();
    void OnButtonExport();

private:
    std::vector<Operation> *_operations;
    SearchBanner* _banner;
    GridAccount *_grid;
    QPushButton* _searchButton, *_exportButton;
    ExportEngine* _exportEngine;

    static void OnEnter(void* caller);
};

#endif
