/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SNAPSHOTSDIALOG_H
#define SNAPSHOTSDIALOG_H

#include <QDialog>
#include <QListWidget>

#include "wxUI.hpp"

class SnapshotsDialog : public QDialog
{
    Q_OBJECT;
    
public: 
    SnapshotsDialog(KissCount* kiss, wxUI *parent);

private slots:  
    void OnOK();
    void OnCreate();
    void OnDelete();
    void OnBackTo();

private:
    KissCount* _kiss;
    wxUI* _wxUI;
    QListWidget* _snapshots;
    // QLineEdit* _oldSnapshots, *_newSnapshots, *_confirmSnapshots;

    void LoadFiles();
};
#endif
