/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef STATSPANEL_H
#define STATSPANEL_H

#include <QtGui>
#include <QListWidgetItem>
#include <QCalendarWidget>
#include <QComboBox>
#include <QListWidget>
#include <QtCharts/QChart>
#include <QtCharts/QChartView>

#include "CostRepartitionBanner.hpp"

#include "view.hpp"
#include <model/model.hpp>

class StatsPanel: public KissPanel
{
    Q_OBJECT;

public:
    StatsPanel(KissCount* kiss, wxUI *parent, bool lowResolution);

    KissPanel* CreatePanel();
    QString GetToolTip();
    void OnShow();

private slots:
    void OnRangeChange(int);
    void OnAccountChange(QListWidgetItem*);

private:
    QCalendarWidget* _calendarFrom, *_calendarTo;
    QComboBox* _monthFrom, *_yearFrom, *_monthTo, *_yearTo;
    CostRepartitionBanner* _costRepartitionBanner;
    int *_categoriesValues;
    QtCharts::QChartView * _chartView;
    QtCharts::QChart *_plot ;
    QString* _categories;  
    std::map<int, int> _categoriesIndexes;
    QBoxLayout *_hbox2, *_vbox2, *_vbox3;
    QListWidget* _account;

    void UpdateStats(int monthFrom, int yearFrom, int monthTo, int yearTo);
};

#endif
