/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef USERSDIALOG_H
#define USERSDIALOG_H

#include <QDialog>
#include <QComboBox>
#include <QLineEdit>

#include "wxUI.hpp"

class UsersDialog : public QDialog
{
    Q_OBJECT;
    
public: 
    UsersDialog(KissCount* kiss, wxUI *parent);

    class ExceptionNewUser {};

private slots:  
    void OnEnter();
    void OnOK();
    void OnCancel();
    void OnNewUser();

private:
    KissCount* _kiss;
    wxUI* _wxUI;
    QComboBox* _users;
    QLineEdit* _password;
};
#endif
