/*
  Copyright 2017 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CALENDARDELEGATE_H
#define CALENDARDELEGATE_H

#include <QtGui>
#include <QStyledItemDelegate>
#include <model/Account.hpp>
#include <QCalendarWidget>

class CalendarDelegate : public QStyledItemDelegate
{
    Q_OBJECT;

public:
    CalendarDelegate(QWidget *parent = 0, std::vector<Account>* accounts=0, bool start=true, QString dateFormat="dd/MM/yyyy") :
	QStyledItemDelegate(parent), _accounts(accounts), _start(start), _dateFormat(dateFormat) {}

    QWidget * createEditor ( QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
    		      const QModelIndex &index) const;

private slots:
    void OnCalendarClicked(const QDate &date);
    void OnCalendarSelectionChanged(void);

private:
    std::vector<Account>* _accounts;
    bool _start;
    QDate _date;
    QString _dateFormat;
};

#endif
