/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <QtGui>
#include <QtWidgets>

#include "ChoiceDelegate.hpp"

#include <iostream>

QWidget * ChoiceDelegate::createEditor (QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const
{
    QComboBox* combo = new QComboBox(parent);

    for(int i=0; i<_nbValues; i++)
    	combo->addItem(_values[i]);

    return combo;
}

void ChoiceDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
				  const QModelIndex &index) const
{
    QComboBox *combo = qobject_cast<QComboBox *>(editor);
    model->setData(index, qVariantFromValue(combo->currentText()));
}

void ChoiceDelegate::setEditorData(QWidget *editor,
				   const QModelIndex &index) const
 {
     QComboBox* combo = qobject_cast<QComboBox *>(editor);
     int i = combo->findText(index.data().toString());

     if (i != -1) combo->setCurrentIndex(i);
 }
