/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CHOICEDELEGATE_H
#define CHOICEDELEGATE_H

#include "TableViewDelegate.hpp"
#include <QString>

class ChoiceDelegate : public TableViewDelegate
{
    Q_OBJECT;

public:
    ChoiceDelegate(QWidget *parent = 0, QString* values=0, int nbValues=0) : TableViewDelegate(parent), _values(values), _nbValues(nbValues) {}

    QWidget * createEditor ( QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
		      const QModelIndex &index) const;

private:
    QString* _values;
    int _nbValues;
    bool _editable;
};

#endif
