/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef TABDELEGATE_H
#define TABDELEGATE_H

#include "TableViewDelegate.hpp"
#include <QString>

class TabDelegate : public TableViewDelegate
{
    Q_OBJECT;

public:
    TabDelegate(QWidget *parent = 0, std::vector<Operation>* operations=0, QCompleter* completer=0) : 
	TableViewDelegate(parent), _operations(operations),
	_completer(completer)
    {}

    QWidget * createEditor ( QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
    		      const QModelIndex &index) const;
    bool editorEvent ( QEvent * event, QAbstractItemModel * model, const QStyleOptionViewItem & option, const QModelIndex & index );

private:
    std::vector<Operation>* _operations;
    QCompleter* _completer;
};

#endif
