/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef VIEW_H
#define VIEW_H

#include <QColor>

namespace view {
    const QColor OWN_CYAN(0x99, 0xCC, 0xFF);
    const QColor OWN_YELLOW(0xFF, 0xFF, 0x99);
    const QColor OWN_GREEN(0x3D, 0xEB, 0x3D);
    const QString DEFAULT_FONT_NAME("Liberation Sans");
    const int DEFAULT_FONT_SIZE = 12;

#define DEFAULT_FONT(font_name)  QFont font_name;
};

#define DELETE_ICON RESOURCES_ROOT "icons/delete.png"
#define CHECKED_ICON  RESOURCES_ROOT "icons/check.png"

#define USER_ICON RESOURCES_ROOT "icons/user.png"
#define STATS_ICON   RESOURCES_ROOT "icons/charts.png"
#define SEARCH_ICON  RESOURCES_ROOT "icons/search.png"
#define PREFS_ICON   RESOURCES_ROOT "icons/preferences.png"
#define IMPORT_ICON   RESOURCES_ROOT "icons/import.png"
#define EXPORT_ICON   RESOURCES_ROOT "icons/export.png"
#define CHANGE_USER_ICON RESOURCES_ROOT "icons/switch_user.png"
#define ABOUT_ICON  RESOURCES_ROOT "icons/about.png"
#define QUIT_ICON   RESOURCES_ROOT "icons/exit.png"

#define USER_LOW_ICON RESOURCES_ROOT "icons/user_low.png"
#define STATS_LOW_ICON   RESOURCES_ROOT "icons/charts_low.png"
#define SEARCH_LOW_ICON  RESOURCES_ROOT "icons/search_low.png"
#define PREFS_LOW_ICON   RESOURCES_ROOT "icons/preferences_low.png"
#define IMPORT_LOW_ICON   RESOURCES_ROOT "icons/import_low.png"
#define EXPORT_LOW_ICON   RESOURCES_ROOT "icons/export_low.png"
#define CHANGE_USER_LOW_ICON RESOURCES_ROOT "icons/switch_user_low.png"
#define ABOUT_LOW_ICON  RESOURCES_ROOT "icons/about_low.png"
#define QUIT_LOW_ICON   RESOURCES_ROOT "icons/exit_low.png"

#define LANG_ROOT RESOURCES_ROOT "po/"

#endif
